E-Money

E-Money Order API

Create E-Money order via Paylabs API.

Request Address

URL: ${ROOT_URL}/payment/v2.3/ewallet/create

HTTPMethod: POST

EndpointUrl: /payment/v2.3/ewallet/create

E-Money Order Request Parameters

Data Signing Rules

Field NameTypeValueRequired
Content-TypeString(30)Fixed value "application/json;charset=utf-8"Yes
X-TIMESTAMPString(29)Current time, format 2022-09-16T16:58:47.964+07:00Yes
X-SIGNATUREString(64)Signature. For details please check Data Signing RulesYes
X-PARTNER-IDString(20)Merchant IDYes
X-REQUEST-IDString(64)Unique ID for each requestYes

Body

ParameterTypeRequiredRemarks
requestIdString(64)YesUnique ID for each request
merchantIdString(20)YesThe unique identifier provided by payment gateway to the merchant
storeIdString(30)NoOnly if merchant has branches and wish to create order using its branch ID
paymentTypeString(20)YesPayment Type, see Payment Type
amountDecimal(12,2)YesAmount in Indonesia Rupiah
feeTypeString(3)NoFee deduction type: BEN/OUR. Default BEN. OUR adds fees to order amount automatically.
merchantTradeNoString(32)YesTransaction unique identifier defined by merchant
notifyUrlString(200)NoThe URL that will hit by API if payment success
+ paymentParamsObjectNoAdditional parameters specific to the channels. See Payment Type parameters.
productNameString(100)YesThe name of the transaction's goods or services
+ productInfoArray<Object>(30)NoThe details of the transaction's goods or services
- idString(10)YesProduct ID
- nameString(32)YesProduct Name
- pricedecimal(12,2)YesAmount in IDR, supports two decimals
- typeString(20)YesProduct Type
- urlString(200)NoProduct URL
- quantityNumber(4)YesProduct Quantity

paymentType

Payment TypeCode
DANA E-Money (Support Refund)DANABALANCE
Shopee E-Money (Support Refund)SHOPEEBALANCE
Linkaja E-Money (Support Refund)LINKAJABALANCE
OVO E-Money (refunds not supported)OVOBALANCE
GoPay E-Money (Support Refund)GOPAYBALANCE

paymentParams

DANABALANCE, SHOPEEBALANCE, LINKAJABALANCE, GOPAYBALANCE

ParameterTypeRequiredRemarks
redirectUrlString(200)YesEither the order is success or fail will redirect to this callback URL

OVOBALANCE

ParameterTypeRequiredRemarks
redirectUrlString(200)NoEither the order is success or fail will redirect to this callback URL
phoneNumberString(200)NoCustomer's OVO account number; mobilePayUrl not returned when provided

E-Money Order Response Parameters

Header

Data Signing Rules

Field NameTypeValueRequired
Content-TypeString(30)Fixed value "application/json;charset=utf-8"Yes
X-TIMESTAMPString(29)Current time, format 2022-09-16T16:58:47.964+07:00Yes
X-SIGNATUREString(64)Signature. For details please check Data Signing RulesYes
X-PARTNER-IDString(20)Merchant IDYes
X-REQUEST-IDString(64)Unique ID for each requestYes

Body

Error Code

ParameterTypeRequiredRemarks
requestIdString(64)YesUnique identifier on every request
errCodeString(32)NoFor details please see Error Code section
errCodeDesString(128)NoError details based on error code
merchantIdString(20)NoMerchant ID
storeIdString(30)NoOnly if using branch ID channel account
paymentTypeString(20)YesType of payments, see Payment Type
requestAmountDecimal(12,2)NoAmount at request
amountDecimal(12,2)YesTransaction Amount, in IDR with two decimals.
If fee type OUR is selected, fees will be added. Fee with decimals is rounded up (10,000.11 → 10,001.00).
merchantTradeNoString(32)YesMerchant order number
createTimeString(16)YesyyyyMMddHHmmss
+ paymentActionsObjectNoPayment URLs (PC, Web, etc.)
- pcPayUrlString(200)NoPC Payment URL
- mobilePayUrlString(200)NoMobile Payment URL
- appDeeplinkString(200)NoOpen App directly
- pushPayString(200)NoCustomer confirms payment within the app
platformTradeNoString(32)NoPaylabs Platform Transaction Number
successTimeString(16)NoyyyyMMddHHmmss
expiredTimeString(16)NoyyyyMMddHHmmss
statusString(32)No01: Pending, 09: Failed, 02: Success
productNameString(100)YesProduct/service name
+ productInfoArray<Object>(30)NoProduct/service details
- idString(10)YesProduct ID
- nameString(32)YesProduct Name
- pricedecimal(12,2)YesAmount in IDR, supports two decimals
- typeString(20)YesProduct Type
- urlString(200)NoProduct URL
- quantityNumber(4)YesProduct Quantity
transFeeRateDecimal(6,6)NoTransaction Rate, six decimals
transFeeAmountDecimal(12,2)NoFees, two decimals
totalTransFeeDecimal(12,2)NoTotal transaction fee rate (excluding vatFee), two decimals
vatFeeDecimal(12,2)NoTaxes, two decimals
payerString(60)NoActual payer name if supported; otherwise null. No supported payment methods currently. Not the payer sent by merchant.
accountNoString(32)NoActual payer account number if supported; otherwise null. No supported payment methods currently.

paymentActions Support

ChannelpcPayUrlmobilePayUrlappDeeplinkpushPay
DanaYYNN
ShopeeNYNN
LinkajaYYNN
OVONCNC
GoPayNYNN

Example

Request

POST /payment/v2.3/ewallet/create
# HTTP Header
Content-Type: application/json;charset=utf-8
X-TIMESTAMP: 2022-09-16T16:58:47.964+07:00
X-SIGNATURE: xxxxxxxxx
X-PARTNER-ID: 010001
X-REQUEST-ID: xxxxxxxxxxxxxxxxxxxxxxxx

# HTTP Body
{
  "merchantId":"0010001",
  "merchantTradeNo":"100100011649755299703",
  "requestId":"200100011649755299703",
  "paymentType":"SHOPEEBALANCE",
  "amount":"10000.00",
  "productName":"Test",
  "paymentParams":{
    "redirectUrl": "http://google.com"
  }
}

Response

POST /payment/v2.3/ewallet/create
# HTTP Header
Content-Type: application/json;charset=utf-8
X-TIMESTAMP: 2022-09-16T16:58:47.964+07:00
X-SIGNATURE: xxxxxxxxx
X-PARTNER-ID: 010001
X-REQUEST-ID: xxxxxxxxxxxxxxxxxxxxxxxx

# HTTP Body
{
  "amount":"10000.00",
  "merchantTradeNo":"100100011649755299703",
  "platformTradeNo":"2022041200000000022",
  "expiredTime":"20220412162641",
  "paymentType":"SHOPEEBALANCE",
  "paymentActions":{
    "mobilePayUrl":"https://wsa.uat.wallet.airpay.co.id/universal-link/wallet/pay?deep_and_deferred=1&token=dFhkbmR1bTBIamhWkALJbE72qKeb2LpWAmThwGAMEXu0oo6lQWWCBMbH6JezjfA"
  },
  "createTime":"20220412162143",
  "merchantId":"0010001",
  "errCode":"0",
  "requestId":"200100011649755299703",
  "productName":"Test",
  "status":"01",
  "transFeeRate":"0",
  "transFeeAmount":"0",
  "totalTransFee":"0",
  "vatFee":"0"
}